searchNodes=[{"doc":"Welcome to AshAuthentication.Pheonix . The ash_authentication_phoenix package extends ash_authentication by adding router helpers, plugs and behaviours that makes adding authentication to an existing Ash-based Phoenix application dead easy. Where to start. Presuming that you already have Phoenix , Ash and AshAuthentication installed and configured, start by adding plugs and routes to your router using AshAuthentication.Phoenix.Router and customising your sign-in page as needed. Customisation There are several methods of customisation available depending on the level of control you would like: Use the generic sign-in liveview - AshAuthentication.Phoenix.SignInLive . Apply overrides using AshAuthentication.Phoenix.Overrides to set your own CSS classes for all components. Build your own sign-in pages using the pre-defined components. Build your own sign-in pages using the generated auth routes.","ref":"AshAuthentication.Phoenix.html","title":"AshAuthentication.Phoenix","type":"module"},{"doc":"The authentication controller generator. Since authentication often requires explicit HTTP requests to do things like set cookies or return Authorization headers, use this module to create an AuthController in your Phoenix application. Example Handling the registration or authentication of a normal web-based user. defmodule MyAppWeb.AuthController do use MyAppWeb , :controller use AshAuthentication.Phoenix.Controller def success ( conn , _activity , user , _token ) do conn |&gt; store_in_session ( user ) |&gt; assign ( :current_user , user ) |&gt; redirect ( to : Routes . page_path ( conn , :index ) ) end def failure ( conn , _activity , _reason ) do conn |&gt; put_status ( 401 ) |&gt; render ( &quot;failure.html&quot; ) end def sign_out ( conn , _params ) do conn |&gt; clear_session ( ) |&gt; render ( &quot;sign_out.html&quot; ) end end Handling registration or authentication of an API user. defmodule MyAppWeb.ApiAuthController do use MyAppWeb , :controller use AshAuthentication.Phoenix.Controller alias AshAuthentication.TokenRevocation def success ( conn , _activity , _user , token ) do conn |&gt; put_status ( 200 ) |&gt; json ( %{ authentication : %{ status : :success , bearer : token } } ) end def failure ( conn , _activity , _reason ) do conn |&gt; put_status ( 401 ) |&gt; json ( %{ authentication : %{ status : :failed } } ) end def sign_out ( conn , _params ) do conn |&gt; revoke_bearer_tokens ( ) |&gt; json ( %{ status : :ok } ) end end","ref":"AshAuthentication.Phoenix.Controller.html","title":"AshAuthentication.Phoenix.Controller","type":"behaviour"},{"doc":"Called when authentication fails.","ref":"AshAuthentication.Phoenix.Controller.html#c:failure/3","title":"AshAuthentication.Phoenix.Controller.failure/3","type":"callback"},{"doc":"Called when a request to sign out is received.","ref":"AshAuthentication.Phoenix.Controller.html#c:sign_out/2","title":"AshAuthentication.Phoenix.Controller.sign_out/2","type":"callback"},{"doc":"Called when authentication (or registration, depending on the provider) has been successful.","ref":"AshAuthentication.Phoenix.Controller.html#c:success/4","title":"AshAuthentication.Phoenix.Controller.success/4","type":"callback"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:activity/0","title":"AshAuthentication.Phoenix.Controller.activity/0","type":"type"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:t/0","title":"AshAuthentication.Phoenix.Controller.t/0","type":"type"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:token/0","title":"AshAuthentication.Phoenix.Controller.token/0","type":"type"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:user/0","title":"AshAuthentication.Phoenix.Controller.user/0","type":"type"},{"doc":"Helper plugs mixed in to your router. When you use AshAuthentication.Phoenix.Router this module is included, so that you can use these plugs in your pipelines.","ref":"AshAuthentication.Phoenix.Plug.html","title":"AshAuthentication.Phoenix.Plug","type":"module"},{"doc":"Attempt to retrieve actors from the Authorization header(s). A wrapper around AshAuthentication.Plug.Helpers.retrieve_from_bearer/2 with the otp_app as extracted from the endpoint.","ref":"AshAuthentication.Phoenix.Plug.html#load_from_bearer/2","title":"AshAuthentication.Phoenix.Plug.load_from_bearer/2","type":"function"},{"doc":"Attempt to retrieve all actors from the connections' session. A wrapper around AshAuthentication.Plug.Helpers.retrieve_from_session/2 with the otp_app as extracted from the endpoint.","ref":"AshAuthentication.Phoenix.Plug.html#load_from_session/2","title":"AshAuthentication.Phoenix.Plug.load_from_session/2","type":"function"},{"doc":"Revoke all token(s) in the Authorization header(s). A wrapper around AshAuthentication.Plug.Helpers.revoke_bearer_tokens/2 with the otp_app as extracted from the endpoint.","ref":"AshAuthentication.Phoenix.Plug.html#revoke_bearer_tokens/2","title":"AshAuthentication.Phoenix.Plug.revoke_bearer_tokens/2","type":"function"},{"doc":"Store the actor in the connections' session.","ref":"AshAuthentication.Phoenix.Plug.html#store_in_session/2","title":"AshAuthentication.Phoenix.Plug.store_in_session/2","type":"function"},{"doc":"Phoenix route generation for AshAuthentication. Using this module imports the macros in this module and the plug functions from AshAuthentication.Phoenix.Plug . Usage Adding authentication to your live-view router is very simple: defmodule MyAppWeb.Router do use MyAppWeb , :router use AshAuthentication.Phoenix.Router pipeline :browser do # ... plug ( :load_from_session ) end pipeline :api do # ... plug ( :load_from_bearer ) end scope &quot;/&quot; , MyAppWeb do pipe_through :browser sign_in_route sign_out_route AuthController auth_routes_for MyApp.Accounts.User , to : AuthController reset_route end","ref":"AshAuthentication.Phoenix.Router.html","title":"AshAuthentication.Phoenix.Router","type":"module"},{"doc":"Generates the routes needed for the various strategies for a given AshAuthentication resource. This is required if you wish to use authentication. Options to - a module which implements the AshAuthentication.Phoenix.Controller behaviour. This is required. path - a string (starting with &quot;/&quot;) wherein to mount the generated routes. scope_opts - any options to pass to the generated scope. Example scope &quot;/&quot; , DevWeb do auth_routes_for ( MyApp.Accounts.User , to : AuthController , path : &quot;/authentication&quot; , scope_opts : [ host : &quot;auth.example.com&quot; ] ) end","ref":"AshAuthentication.Phoenix.Router.html#auth_routes_for/2","title":"AshAuthentication.Phoenix.Router.auth_routes_for/2","type":"macro"},{"doc":"Generates a generic, white-label password reset page using LiveView and the components in AshAuthentication.Phoenix.Components . Available options are: path the path under which to mount the live-view. Defaults to &quot;/password-reset&quot; . live_view the name of the live view to render. Defaults to AshAuthentication.Phoenix.ResetLive . as which is passed to the generated live route. Defaults to :auth . overrides specify any override modules for customisation. See AshAuthentication.Phoenix.Overrides for more information. all other options are passed to the generated scope . This is completely optional.","ref":"AshAuthentication.Phoenix.Router.html#reset_route/1","title":"AshAuthentication.Phoenix.Router.reset_route/1","type":"macro"},{"doc":"Generates a generic, white-label sign-in page using LiveView and the components in AshAuthentication.Phoenix.Components . This is completely optional. Available options are: path the path under which to mount the live-view. Defaults to &quot;/sign-in&quot; . live_view the name of the live view to render. Defaults to AshAuthentication.Phoenix.SignInLive . as which is passed to the generated live route. Defaults to :auth . overrides specify any override modules for customisation. See AshAuthentication.Phoenix.Overrides for more information. all other options are passed to the generated scope .","ref":"AshAuthentication.Phoenix.Router.html#sign_in_route/1","title":"AshAuthentication.Phoenix.Router.sign_in_route/1","type":"macro"},{"doc":"Generates a sign-out route which points to the sign_out action in your auth controller. This is optional, but you probably want it.","ref":"AshAuthentication.Phoenix.Router.html#sign_out_route/3","title":"AshAuthentication.Phoenix.Router.sign_out_route/3","type":"macro"},{"doc":"Options that can be passed to auth_routes_for .","ref":"AshAuthentication.Phoenix.Router.html#t:auth_route_options/0","title":"AshAuthentication.Phoenix.Router.auth_route_options/0","type":"type"},{"doc":"A sub-path if required. Defaults to /auth .","ref":"AshAuthentication.Phoenix.Router.html#t:path_option/0","title":"AshAuthentication.Phoenix.Router.path_option/0","type":"type"},{"doc":"Any options which should be passed to the generated scope.","ref":"AshAuthentication.Phoenix.Router.html#t:scope_opts_option/0","title":"AshAuthentication.Phoenix.Router.scope_opts_option/0","type":"type"},{"doc":"The controller which will handle success and failure.","ref":"AshAuthentication.Phoenix.Router.html#t:to_option/0","title":"AshAuthentication.Phoenix.Router.to_option/0","type":"type"},{"doc":"Renders a very simple banner at the top of the sign-in component. Can show either an image or some text, depending on the provided overrides. Props overrides - A list of override modules. Overrides This component provides the following overrides: :dark_image_class - Css class for the img tag in dark mode. :dark_image_url - A URL for the img src attribute in dark mode. Set to nil to disable. :href_class - CSS class for the a tag. :href_url - A URL for the banner image to link to. Set to nil to disable. :image_class - CSS class for the img tag in dark mode. :image_url - A URL for the img src attribute. Set to nil to disable. :root_class - CSS class for the root div element. :text - Banner text. Set to nil to disable. :text_class - CSS class for the text div . See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Banner.html","title":"AshAuthentication.Phoenix.Components.Banner","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Banner.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Banner.props/0","type":"type"},{"doc":"Helpers which are commonly needed inside the various components.","ref":"AshAuthentication.Phoenix.Components.Helpers.html","title":"AshAuthentication.Phoenix.Components.Helpers","type":"module"},{"doc":"The LiveView Socket contains a reference to the Phoenix endpoint, and from there we can extract the otp_app of the current request.","ref":"AshAuthentication.Phoenix.Components.Helpers.html#otp_app_from_socket/1","title":"AshAuthentication.Phoenix.Components.Helpers.otp_app_from_socket/1","type":"function"},{"doc":"The LiveView Socket contains a refererence to the Phoenix router, and from there we can generate the name of the route helpers module.","ref":"AshAuthentication.Phoenix.Components.Helpers.html#route_helpers/1","title":"AshAuthentication.Phoenix.Components.Helpers.route_helpers/1","type":"function"},{"doc":"A horizontal rule with text. This component is pretty tailwind-specific, but I (@jimsynz) really wanted a certain look. If you think I'm wrong then please let me know. Overrides This component provides the following overrides: :hr_inner_class - CSS class for the inner div element of the horizontal rule. :hr_outer_class - CSS class for the outer div element of the horizontal rule. :root_class - CSS class for the root div element. :text - Text to display in front of the horizontal rule. :text_inner_class - CSS class for the inner div element of the text area. :text_outer_class - CSS class for the outer div element of the text area. See AshAuthentication.Phoenix.Overrides for more information. Props * ` overrides ` - A list of override modules .","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html","title":"AshAuthentication.Phoenix.Components.HorizontalRule","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html#t:props/0","title":"AshAuthentication.Phoenix.Components.HorizontalRule.props/0","type":"type"},{"doc":"Generates a sign-in button for OAuth2. Component heirarchy This is the top-most provider specific component, nested below AshAuthentication.Phoenix.Components.SignIn . Props strategy - The strategy configuration as per AshAuthentication.Info.strategy/2 . Required. overrides - A list of override modules. Overrides This component provides the following overrides: :icon_class - CSS classes for the icon SVG. :link_class - CSS classes for the a element. :root_class - CSS classes for the root div element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.OAuth2.html","title":"AshAuthentication.Phoenix.Components.OAuth2","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#icon/1","title":"AshAuthentication.Phoenix.Components.OAuth2.icon/1","type":"function"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#t:props/0","title":"AshAuthentication.Phoenix.Components.OAuth2.props/0","type":"type"},{"doc":"Generates sign in, registration and reset forms for a resource. Component hierarchy This is the top-most provider-specific component, nested below AshAuthentication.Phoenix.Components.SignIn . Children: AshAuthentication.Phoenix.Components.Password.SignInForm AshAuthentication.Phoenix.Components.Password.RegisterForm AshAuthentication.Phoenix.Components.Password.ResetForm Props strategy - The strategy configuration as per AshAuthentication.Info.strategy/2 . Required. overrides - A list of override modules. Overrides This component provides the following overrides: :hide_class - CSS class to apply to hide an element. :interstitial_class - CSS class for the div element between the form and the button. :register_toggle_text - Toggle text to display when the register form is not showing. :reset_toggle_text - Toggle text to display when the reset form is not showing. :root_class - CSS class for the root div element. :show_first - The form to show on first load. Either :sign_in or :register . :sign_in_toggle_text - Toggle text to display when the sign in form is not showing. :toggler_class - CSS class for the toggler a element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.html","title":"AshAuthentication.Phoenix.Components.Password","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.props/0","type":"type"},{"doc":"Function components for dealing with form input during password authentication. Component hierarchy These function components are consumed by AshAuthentication.Phoenix.Components.Password.SignInForm , AshAuthentication.Phoenix.Components.Password.RegisterForm and AshAuthentication.Phoenix.Components.ResetForm . Overrides This component provides the following overrides: :error_li - CSS class for the li elements on error lists. :error_ul - CSS class for the ul element on error lists. :field_class - CSS class for div elements surrounding the fields. :input_class - CSS class for text/password input elements. :input_class_with_error - CSS class for text/password input elements when there is a validation error. :input_debounce - Number of milliseconds to debounce input by (or nil to disable). :label_class - CSS class for label elements. :submit_class - CSS class for the form submit input element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html","title":"AshAuthentication.Phoenix.Components.Password.Input","type":"module"},{"doc":"Generate a list of errors for a field (if there are any). Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. form - An AshPhoenix.Form . Required. field - The field for which to retrieve the errors. Required. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#error/1","title":"AshAuthentication.Phoenix.Components.Password.Input.error/1","type":"function"},{"doc":"Generate a form field for the configured identity field. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. input_type - Either :text or :email . If not set it will try and guess based on the name of the identity field. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#identity_field/1","title":"AshAuthentication.Phoenix.Components.Password.Input.identity_field/1","type":"function"},{"doc":"Generate a form field for the configured password confirmation entry field. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_confirmation_field/1","title":"AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1","type":"function"},{"doc":"Generate a form field for the configured password entry field. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_field/1","title":"AshAuthentication.Phoenix.Components.Password.Input.password_field/1","type":"function"},{"doc":"Generate an form submit button. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. action - Either :sign_in or :register . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#submit/1","title":"AshAuthentication.Phoenix.Components.Password.Input.submit/1","type":"function"},{"doc":"Generates a default registration form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Password . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - The strategy configuration as per AshAuthentication.Info.strategy/2 . Required. socket - Needed to infer the otp-app from the Phoenix endpoint. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :root_class - CSS class for the root div element. :slot_class - CSS class for the div surrounding the slot. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html","title":"AshAuthentication.Phoenix.Components.Password.RegisterForm","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.RegisterForm.props/0","type":"type"},{"doc":"Generates a default password reset form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Password . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - The configuration map as per AshAuthentication.Info.strategy/2 . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. Set to false to disable. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :reset_flash_text - Text for the flash message when a request is received. Set to nil to disable. :root_class - CSS class for the root div element. :slot_class - CSS class for the div surrounding the slot. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html","title":"AshAuthentication.Phoenix.Components.Password.ResetForm","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.ResetForm.props/0","type":"type"},{"doc":"Generates a default sign in form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Password . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - The configuration map as per AshAuthentication.Info.strategy/2 . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. Set to false to disable. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :root_class - CSS class for the root div element. :slot_class - CSS class for the div surrounding the slot. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html","title":"AshAuthentication.Phoenix.Components.Password.SignInForm","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.SignInForm.props/0","type":"type"},{"doc":"Renders a password-reset form. Component heirarchy Children: AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props token - The reset token. overrides - A list of override modules. Overrides This component provides the following overrides: :root_class - CSS class for the root div element. :show_banner - Whether or not to show the banner. :strategy_class - CSS class for a div surrounding each strategy component. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Reset.html","title":"AshAuthentication.Phoenix.Components.Reset","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Reset.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Reset.props/0","type":"type"},{"doc":"Generates a default password reset form. Component heirarchy This is a child of AshAuthentication.Phoenix.Components.Reset . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 AshAuthentication.Phoenix.Components.Password.Input.error/1 Props token - The reset token. socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.Info.strategy/2 . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. Set to false to disable. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :root_class - CSS class for the root div element. :spacer_class - CSS classes for space between the password input and submit elements. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html","title":"AshAuthentication.Phoenix.Components.Reset.Form","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Reset.Form.props/0","type":"type"},{"doc":"Renders sign in mark-up for an authenticated resource. This means that it will render sign-in UI for all of the authentication strategies for a resource. For each strategy configured on the resource a component name is inferred (e.g. AshAuthentication.Strategy.Password becomes AshAuthentication.Phoenix.Components.Strategy.Passowrd ) and is rendered into the output. Component hierarchy This is the top-most authentication component. Children: AshAuthentication.Phoenix.Components.Strategy.Password . AshAuthentication.Phoenix.Components.Strategy.OAuth2 . Overrides This component provides the following overrides: :root_class - CSS class for the root div element. :show_banner - Whether or not to show the banner. :strategy_class - CSS class for a div surrounding each strategy component. See AshAuthentication.Phoenix.Overrides for more information. Props overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.SignIn.html","title":"AshAuthentication.Phoenix.Components.SignIn","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.SignIn.html#t:props/0","title":"AshAuthentication.Phoenix.Components.SignIn.props/0","type":"type"},{"doc":"Behaviour for overriding component styles and attributes in your application. The default implementation is AshAuthentication.Phoenix.Overrides.Default which uses TailwindCSS to generate a fairly generic looking user interface. You can override this by adding your own override modules to the AshAuthentication.Phoenix.Router.sign_in_route/1 macro in your router: sign_in_route overrides : [ MyAppWeb.AuthOverrides , AshAuthentication.Phoenix.Overrides.Default ] and defining lib/my_app_web/auth_overrides.ex within which you can set any overrides. The use macro defines overridable versions of all callbacks which return nil , so you only need to define the functions that you care about. Each of the override modules specified in the config will be called in the order that they're specified, so you can still use the defaults if you just override some properties. defmodule MyAppWeb.AuthOverrides do use AshAuthentication.Phoenix.Overrides alias AshAuthentication.Phoenix.Components override Components.Banner do set :image_url , &quot;/images/sign_in_logo.png&quot; end end","ref":"AshAuthentication.Phoenix.Overrides.html","title":"AshAuthentication.Phoenix.Overrides","type":"module"},{"doc":"Define overrides for a specific component.","ref":"AshAuthentication.Phoenix.Overrides.html#override/2","title":"AshAuthentication.Phoenix.Overrides.override/2","type":"macro"},{"doc":"Override a setting within a component.","ref":"AshAuthentication.Phoenix.Overrides.html#set/2","title":"AshAuthentication.Phoenix.Overrides.set/2","type":"macro"},{"doc":"This is the default overrides for our component UI. The CSS styles are based on TailwindCSS .","ref":"AshAuthentication.Phoenix.Overrides.Default.html","title":"AshAuthentication.Phoenix.Overrides.Default","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Overrides.Default.html#overrides/0","title":"AshAuthentication.Phoenix.Overrides.Default.overrides/0","type":"function"},{"doc":"Override introspection.","ref":"AshAuthentication.Phoenix.Overrides.Info.html","title":"AshAuthentication.Phoenix.Overrides.Info","type":"module"},{"doc":"Returns a map of all known overridable modules and their overrides.","ref":"AshAuthentication.Phoenix.Overrides.Info.html#all_overridable_modules/0","title":"AshAuthentication.Phoenix.Overrides.Info.all_overridable_modules/0","type":"function"},{"doc":"Auto generates documentation and helpers for components.","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html","title":"AshAuthentication.Phoenix.Overrides.Overridable","type":"behaviour"},{"doc":"","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html#c:__overrides__/0","title":"AshAuthentication.Phoenix.Overrides.Overridable.__overrides__/0","type":"callback"},{"doc":"Retrieve configuration for a potentially overriden value.","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html#override_for/3","title":"AshAuthentication.Phoenix.Overrides.Overridable.override_for/3","type":"macro"},{"doc":"A generic, white-label password reset page. This live-view can be rendered into your app using the AshAuthentication.Phoenix.Router.reset_route/1 macro in your router (or by using Phoenix.LiveView.Controller.live_render/3 directly in your markup). This live-view looks for the token URL parameter, and if found passes it to AshAuthentication.Phoenix.Components.Reset . Overrides This component provides the following overrides: :reset_id - Element ID for the Reset LiveComponent. :root_class - CSS class for the root div element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.ResetLive.html","title":"AshAuthentication.Phoenix.ResetLive","type":"module"},{"doc":"A generic, white-label sign-in page. This live-view can be rendered into your app using the AshAuthentication.Phoenix.Router.sign_in_route/1 macro in your router (or by using Phoenix.LiveView.Controller.live_render/3 directly in your markup). This live-view finds all Ash resources with an authentication configuration (via AshAuthentication.authenticated_resources/1 ) and renders the appropriate UI for their providers using AshAuthentication.Phoenix.Components.SignIn . Overrides This component provides the following overrides: :root_class - CSS class for the root div element. :sign_in_id - Element ID for the SignIn LiveComponent. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.SignInLive.html","title":"AshAuthentication.Phoenix.SignInLive","type":"module"},{"doc":"Ensures that any loaded users which are present in a conn's assigns are also present in a live view socket's assigns. Typical usage is via the ash_authentication_live_session/2 macro, but can also manually called like so: scope &quot;/&quot; , ExampleWeb do pipe_through ( :browser ) live_session :authenticated , on_mount : LiveSession , session : { LiveSession , :session , [ ] } do live &quot;/&quot; , ExampleLive end end","ref":"AshAuthentication.Phoenix.LiveSession.html","title":"AshAuthentication.Phoenix.LiveSession","type":"module"},{"doc":"Generate a live session wherein all subject assigns are copied from the conn into the socket.","ref":"AshAuthentication.Phoenix.LiveSession.html#ash_authentication_live_session/3","title":"AshAuthentication.Phoenix.LiveSession.ash_authentication_live_session/3","type":"macro"},{"doc":"Supplements the session with any current_X assigns which are authenticated resource records from the conn.","ref":"AshAuthentication.Phoenix.LiveSession.html#generate_session/1","title":"AshAuthentication.Phoenix.LiveSession.generate_session/1","type":"function"},{"doc":"Inspects the incoming session for any subject_name -&gt; subject values and loads them into the socket's assigns. For example a session containing {&quot;user&quot;, &quot;user?id=aa6c179c-ee75-4d49-8796-528c2981b396&quot;} becomes an assign called current_user with the loaded user as the value.","ref":"AshAuthentication.Phoenix.LiveSession.html#on_mount/4","title":"AshAuthentication.Phoenix.LiveSession.on_mount/4","type":"function"},{"doc":"The ash_authentication_phoenix package extends ash_authentication by adding router helpers, plugs and behaviours that makes adding authentication to an existing Ash-based Phoenix application dead easy.","ref":"readme.html","title":"Read Me","type":"extras"},{"doc":"See the official documentation for more. Additionally, documentation for the latest release will be available on hexdocs and for the main branch .","ref":"readme.html#documentation","title":"Read Me - Documentation","type":"extras"},{"doc":"To contribute updates, fixes or new features please fork and open a pull-request against main . Please use conventional commits - this allows us to dynamically generate the changelog. Feel free to ask any questions on out GitHub discussions page .","ref":"readme.html#contributing","title":"Read Me - Contributing","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"Read Me - License","type":"extras"},{"doc":"In this 10 minute tutorial we create a new empty Example Phoenix application which provides the functionality to register users with their email address and a password. Registered users can sign in and out. We assumes that you have Elixir version 1.14.x (check with elixir -v ) and Phoenix 1.7 (check with mix phx.new --version ) installed. We also assume that you have a PostgreSQL database running which we use to persist the user data.","ref":"getting-started-with-ash-authentication-phoenix.html","title":"Getting Started Ash Authentication Phoenix","type":"extras"},{"doc":"We start with a new Phoenix application and use the --no-ecto flag to skip the Ecto setup. $ mix phx.new example --no-ecto $ cd example","ref":"getting-started-with-ash-authentication-phoenix.html#green-field","title":"Getting Started Ash Authentication Phoenix - Green Field","type":"extras"},{"doc":"We need to add the following dependencies: mix.exs defmodule Example.MixProject do use Mix.Project # ... defp deps do [ # ... # add these lines --&gt; { :ash , &quot;~&gt; 2.5.11&quot; } , { :ash_authentication , &quot;~&gt; 3.7.3&quot; } , { :ash_authentication_phoenix , &quot;~&gt; 1.4.7&quot; } , { :ash_postgres , &quot;~&gt; 1.3.2&quot; } , { :elixir_sense , github : &quot;elixir-lsp/elixir_sense&quot; , only : [ :dev , :test ] } # &lt;-- add these lines ] end # ... Let's fetch everything: $ mix deps.get","ref":"getting-started-with-ash-authentication-phoenix.html#application-dependencies","title":"Getting Started Ash Authentication Phoenix - Application Dependencies","type":"extras"},{"doc":"We can make our life easier and the code more consistent by adding formatters to the project. We will use Elixir's built-in formatter for this. .formatter.exs [ import_deps : [ :phoenix , # add these lines --&gt; :ash , :ash_authentication_phoenix , :ash_postgres # &lt;-- add these lines ] , plugins : [ Phoenix.LiveView.HTMLFormatter ] , inputs : [ &quot;*.{heex,ex,exs}&quot; , &quot;{config,lib,test}/**/*.{heex,ex,exs}&quot; ] ]","ref":"getting-started-with-ash-authentication-phoenix.html#formatter","title":"Getting Started Ash Authentication Phoenix - Formatter","type":"extras"},{"doc":"For Phoenix 1.7 we need to change helpers: false to helpers: true in the router section: lib/example_web.ex defmodule ExampleWeb do # ... def router do quote do use Phoenix.Router , helpers : true # &lt;-- Change this line # ...","ref":"getting-started-with-ash-authentication-phoenix.html#phoenix-1-7-compatibility","title":"Getting Started Ash Authentication Phoenix - Phoenix 1.7 compatibility","type":"extras"},{"doc":"We use AshPostgres to handle the database tables for our application. We need to create a new Repo module for that: lib/example/repo.ex defmodule Example.Repo do use AshPostgres.Repo , otp_app : :example def installed_extensions do [ &quot;uuid-ossp&quot; , &quot;citext&quot; ] end end We have to configure the Repo in config/config.exs . While doing that we also configure other stuff which we need later. config/config.exs # ... import Config # add these lines --&gt; config :example , ash_apis : [ Example.Accounts ] config :example , ecto_repos : [ Example.Repo ] config :ash , :use_all_identities_in_manage_relationship? , false # &lt;-- add these lines # ... We need to add the Repo to the supervision tree in lib/example/application.ex : ** lib/example/application.ex ** defmodule Example.Application do # ... @impl true def start ( _type , _args ) do children = [ # ... # add these lines --&gt; Example.Repo , { AshAuthentication.Supervisor , otp_app : :example } # &lt;-- add these lines ] # ... Database Configuration In case you have other usernames and passwords for your database you need to change the following values. We use the default postgres user and password. config/dev.exs import Config # add these lines --&gt; config :example , Example.Repo , username : &quot;postgres&quot; , password : &quot;postgres&quot; , hostname : &quot;localhost&quot; , database : &quot;example_dev&quot; , port : 5432 , show_sensitive_data_on_connection_error : true , pool_size : 10 # &lt;-- add these lines # ... config/test.exs import Config # add these lines --&gt; config :example , Example.Repo , username : &quot;postgres&quot; , password : &quot;postgres&quot; , hostname : &quot;localhost&quot; , database : &quot;example_test \#{ System . get_env ( &quot;MIX_TEST_PARTITION&quot; ) } &quot; , pool : Ecto.Adapters.SQL.Sandbox , pool_size : 10 # &lt;-- add these lines config/runtime.exs import Config # ... if config_env ( ) == :prod do # add these lines --&gt; database_url = System . get_env ( &quot;DATABASE_URL&quot; ) || raise &quot;&quot;&quot; environment variable DATABASE_URL is missing. For example: ecto://USER:PASS@HOST/DATABASE &quot;&quot;&quot; config :example , Example.Repo , url : database_url , pool_size : String . to_integer ( System . get_env ( &quot;POOL_SIZE&quot; ) || &quot;10&quot; ) # &lt;-- add these lines # ...","ref":"getting-started-with-ash-authentication-phoenix.html#create-and-configure-the-repo","title":"Getting Started Ash Authentication Phoenix - Create and configure the Repo","type":"extras"},{"doc":"We need to create an Accounts API in our application to provide a User and a Token resource. For that we create a couple of new files and one new directory. At the end we should have the following directory structure: lib/example ├── accounts │   ├── registry.ex │   ├── token.ex │   └── user.ex ├── accounts.ex ... lib/example/accounts.ex defmodule Example.Accounts do use Ash.Api resources do registry Example.Accounts.Registry end end lib/example/accounts/user.ex defmodule Example.Accounts.User do use Ash.Resource , data_layer : AshPostgres.DataLayer , extensions : [ AshAuthentication ] attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false attribute :hashed_password , :string , allow_nil? : false , sensitive? : true end authentication do api Example.Accounts strategies do password :password do identity_field ( :email ) end end tokens do enabled? ( true ) token_resource ( Example.Accounts.Token ) signing_secret ( Application . get_env ( :example , ExampleWeb.Endpoint ) [ :secret_key_base ] ) end end postgres do table &quot;users&quot; repo Example.Repo end identities do identity :unique_email , [ :email ] end end lib/example/accounts/token.ex defmodule Example.Accounts.Token do use Ash.Resource , data_layer : AshPostgres.DataLayer , extensions : [ AshAuthentication.TokenResource ] token do api Example.Accounts end postgres do table &quot;tokens&quot; repo Example.Repo end end Next, let's define our registry: lib/example/accounts/registry.ex defmodule Example.Accounts.Registry do use Ash.Registry , extensions : [ Ash.Registry.ResourceValidations ] entries do entry Example.Accounts.User entry Example.Accounts.Token end end Migration and Create Now is a good time to create the database and run the migrations: $ mix ash_postgres.create $ mix ash_postgres.generate_migrations --name add_user_and_token $ mix ash_postgres.migrate In case you want to drop the database and start over again during development you can use mix ash_postgres.drop followed by mix ash_postgres.create and mix ash_postgres.migrate .","ref":"getting-started-with-ash-authentication-phoenix.html#create-an-accounts-api","title":"Getting Started Ash Authentication Phoenix - Create an Accounts API","type":"extras"},{"doc":"ash_authentication_phoenix includes several helper macros which can generate Phoenix routes for you. For that you need to add 6 lines in the router module: lib/example_web/router.ex defmodule ExampleWeb.Router do use ExampleWeb , :router use AshAuthentication.Phoenix.Router # &lt;--- Add this line pipeline :browser do plug :accepts , [ &quot;html&quot; ] plug :fetch_session plug :fetch_live_flash plug :put_root_layout , { ExampleWeb.Layouts , :root } plug :protect_from_forgery plug :put_secure_browser_headers plug :load_from_session # &lt;--- Add this line end pipeline :api do plug :accepts , [ &quot;json&quot; ] plug :load_from_bearer # &lt;--- Add this line end scope &quot;/&quot; , ExampleWeb do pipe_through :browser # add these lines --&gt; sign_in_route ( ) sign_out_route AuthController auth_routes_for Example.Accounts.User , to : AuthController # &lt;-- add these lines get &quot;/&quot; , PageController , :home end # ... Generated routes Given the above configuration you should see the following in your routes: # mix phx.routes Generated example app auth_path GET / sign - in AshAuthentication.Phoenix.SignInLive :sign_in auth_path GET / sign - out ExampleWeb.AuthController :sign_out auth_path * / auth / user / password / register ExampleWeb.AuthController { :user , :password , :register } auth_path * / auth / user / password / sign_in ExampleWeb.AuthController { :user , :password , :sign_in } page_path GET / ExampleWeb.PageController :home ...","ref":"getting-started-with-ash-authentication-phoenix.html#ashauthentication-phoenix-router","title":"Getting Started Ash Authentication Phoenix - AshAuthentication.Phoenix.Router","type":"extras"},{"doc":"While running mix phx.routes you probably saw the warning message that the ExampleWeb.AuthController.init/1 is undefined . Let's fix that by creating a new controller: lib/my_app_web/controllers/auth_controller.ex defmodule ExampleWeb.AuthController do use ExampleWeb , :controller use AshAuthentication.Phoenix.Controller def success ( conn , _activity , user , _token ) do return_to = get_session ( conn , :return_to ) || ~p&quot;/&quot; conn |&gt; delete_session ( :return_to ) |&gt; store_in_session ( user ) |&gt; assign ( :current_user , user ) |&gt; redirect ( to : return_to ) end def failure ( conn , _activity , _reason ) do conn |&gt; put_status ( 401 ) |&gt; render ( &quot;failure.html&quot; ) end def sign_out ( conn , _params ) do return_to = get_session ( conn , :return_to ) || ~p&quot;/&quot; conn |&gt; clear_session ( ) |&gt; redirect ( to : return_to ) end end lib/example_web/controller/auth_html.ex defmodule ExampleWeb.AuthHTML do use ExampleWeb , :html embed_templates &quot;auth_html/*&quot; end lib/example_web/controllers/auth_html/failure.html.heex &lt;h1 class=&quot;text-2xl&quot;&gt;Authentication Error&lt;/h1&gt; Tailwind If you plan on using our default Tailwind -based components without overriding them you will need to modify your assets/tailwind.config.js to include the ash_authentication_phoenix dependency: assets/tailwind.config.js // See the Tailwind configuration guide for advanced usage // https://tailwindcss.com/docs/configuration const plugin = require(&quot;tailwindcss/plugin&quot;) module.exports = { content: [ &quot;./js/**/*.js&quot;, &quot;../lib/*_web.ex&quot;, &quot;../lib/*_web/**/*.*ex&quot;, &quot;../deps/ash_authentication_phoenix/**/*.ex&quot; // &lt;-- Add this line ], // ...","ref":"getting-started-with-ash-authentication-phoenix.html#ashauthentication-phoenix-controller","title":"Getting Started Ash Authentication Phoenix - AshAuthentication.Phoenix.Controller","type":"extras"},{"doc":"To see how the authentication works we replace the default Phoenix home.html.eex with a minimal example which has a top navbar. On the right side it shows the @current_user and a sign out button. If you are not signed in you will see a sign in button. lib/example_web/controllers/page_html/home.html.heex &lt;nav class=&quot;bg-gray-800&quot;&gt; &lt;div class=&quot;px-2 mx-auto max-w-7xl sm:px-6 lg:px-8&quot;&gt; &lt;div class=&quot;relative flex items-center justify-between h-16&quot;&gt; &lt;div class=&quot;flex items-center justify-center flex-1 sm:items-stretch sm:justify-start&quot;&gt; &lt;div class=&quot;block ml-6&quot;&gt; &lt;div class=&quot;flex space-x-4&quot;&gt; &lt;div class=&quot;px-3 py-2 text-xl font-medium text-white &quot;&gt; Ash Demo &lt;/div&gt; &lt;/div&gt; &lt;/div&gt; &lt;/div&gt; &lt;div class=&quot;absolute inset-y-0 right-0 flex items-center pr-2 sm:static sm:inset-auto sm:ml-6 sm:pr-0&quot;&gt; &lt;%= if @current_user do %&gt; &lt;span class=&quot;px-3 py-2 text-sm font-medium text-white rounded-md&quot;&gt; &lt;%= @current_user.email %&gt; &lt;/span&gt; &lt;a href=&quot;/sign-out&quot; class=&quot;rounded-lg bg-zinc-100 px-2 py-1 text-[0.8125rem] font-semibold leading-6 text-zinc-900 hover:bg-zinc-200/80 active:text-zinc-900/70&quot; &gt; Sign out &lt;/a&gt; &lt;% else %&gt; &lt;a href=&quot;/sign-in&quot; class=&quot;rounded-lg bg-zinc-100 px-2 py-1 text-[0.8125rem] font-semibold leading-6 text-zinc-900 hover:bg-zinc-200/80 active:text-zinc-900/70&quot; &gt; Sign In &lt;/a&gt; &lt;% end %&gt; &lt;/div&gt; &lt;/div&gt; &lt;/div&gt; &lt;/nav&gt; &lt;div class=&quot;py-10&quot;&gt; &lt;header&gt; &lt;div class=&quot;px-4 mx-auto max-w-7xl sm:px-6 lg:px-8&quot;&gt; &lt;h1 class=&quot;text-3xl font-bold leading-tight tracking-tight text-gray-900&quot;&gt;Demo&lt;/h1&gt; &lt;/div&gt; &lt;/header&gt; &lt;main&gt; &lt;div class=&quot;mx-auto max-w-7xl sm:px-6 lg:px-8&quot;&gt; &lt;div class=&quot;px-4 py-8 sm:px-0&quot;&gt; &lt;div class=&quot;border-4 border-gray-200 border-dashed rounded-lg h-96&quot;&gt;&lt;/div&gt; &lt;/div&gt; &lt;/div&gt; &lt;/main&gt; &lt;/div&gt;","ref":"getting-started-with-ash-authentication-phoenix.html#minimal-example","title":"Getting Started Ash Authentication Phoenix - Minimal Example","type":"extras"},{"doc":"You can now start Phoenix and visit localhost:4000 from your browser. $ mix phx.server Sign In Visit localhost:4000/sign-in from your browser. The sign in page shows a link to register a new account. Sign Out Visit localhost:4000/sign-out from your browser.","ref":"getting-started-with-ash-authentication-phoenix.html#start-phoenix","title":"Getting Started Ash Authentication Phoenix - Start Phoenix","type":"extras"}]